#pragma once
#include "RepositoryFile.h"

template <class T> 
class RepositoryFileCSV : public RepositoryFile<T>
{


public:
	RepositoryFileCSV(string);
	void saveToFile();
	void loadFromFile();
	~RepositoryFileCSV();
};


template<class T>
RepositoryFileCSV<T>::RepositoryFileCSV(string name):RepositoryFile<T>(name){
    this->loadFromFile();
}

template<class T>
RepositoryFileCSV<T>::~RepositoryFileCSV()
{
}

template<class T>
void RepositoryFileCSV<T>::saveToFile()
{
	
	ofstream f(this->fileName);
	for (T crt : this->elements) {
		f << crt.toStringDelimiter(',') << endl;
	}
    f.close();
}

template<class T>
void RepositoryFileCSV<T>::loadFromFile()
{
	string line;
	ifstream f(this->fileName);
	while (std::getline(f, line)) {
		T ob(line, ',');
		this->elements.push_back(ob);
	}

}